#include "Global.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>

int main()
{

	double diff;		//the difference between the current and the past value
				//of the array that holds the temperatures
	int i,j,z,x;		//decleration of variables used for loops
	int dim;		//dimension for the array
	char *temp;		//temporary pointer for processing the file
	struct timeval start_time, end_time;	//declaration of structs for time counting
	FILE *file;		//pointer to FILE


	temp=(char *)malloc(10*sizeof(char));  	//allocating memory for temp	

	file = fopen("input.txt", "r");		//opening the input file 
	fscanf(file,"%s",temp);			//reading from input... 
	fscanf(file,"%d",&dim);			//...array dimension...
	fscanf(file,"%s",temp);			
	fscanf(file,"%lf",&epsilon);		//...and epsilon

	N = dim;		//initializing the array lines...
	M = dim;		//...and columns
	double *after;	//Array containing the values after running Jakobi
	double *before;	//Values from input
	double *temp2;

	after = (double *)malloc((N*M)*sizeof(double));		//allocating memory for after...
	before = (double *)malloc((N*M)*sizeof(double));	//...and before with the appropriate size as...
								//...it is described in the input file


	while(!feof(file))	//Reading from input file until the end of it
	{
		fscanf(file,"%d%d", &i, &j);		//...the subscripts...
		fscanf(file,"%lf", (before+i*N+j));	//...and the original values
		*(after+i*N+j)=*(before+i*N+j);		//Initializing "array" with the values of before "array"

	}
	fclose(file);		//closing the file

	gettimeofday( &start_time, NULL );	//Getting the start time
	//Jacobi Algorithm
	for (;;)
	{
		//update the before array with the new values
		//this is not necessary for the first loop because they both have the same
		//values.
		temp2=before;
		before=after;
		after=temp2;

		diff = 0.0;	//Setting diff at zero value in order to check the
				//new differences

		//Calculate the new temperature of a specific point
		for ( i=1; i < (N-1); i++ )
		{
			for ( j=1; j < (M-1); j++ )
			{
				*(after+i*N+j) = 0.25 * ( *(before+(i-1)*N+j) + *(before+(i+1)*N+j) + *(before+i*N+(j-1)) + *(before+i*N+(j+1)) );	
				if ( fabs(*(after+i*N+j) - *(before+i*N+j) ) > diff )
				{
					diff = fabs( *(after+i*N+j) - *(before+i*N+j) );	//Save the greater difference between the
												//elements of before and after array
				}
			}
		}


		//If we achieved the diff to be less of desired value we then exit 
		//the Jacobi Algorithm
		if ( diff <= epsilon )
			break;

	}
	gettimeofday( &end_time, NULL );	//Getting the end time

	//Print the time (in seconds) that the Jacobi Algorithm took
	printf("seconds = %f\n", (double)((1000000 * end_time.tv_sec + end_time.tv_usec) - ( 1000000 * start_time.tv_sec + 												start_time.tv_usec))/1000000);

	file = fopen("output.txt", "w");	//create and open the output file
	for ( i=0; i < N; i++ )
	{
		for ( j=0; j < M; j++ )
		{
			fprintf(file,"%d %d %lf\n", i, j, *(before+i*N+j));	//save on the output file the results
		}
		fprintf(file,"\n");	//after every 400 lines we print a new line
					//because of the constrain that the printing script sets
	}
	fclose(file);	// close the output file
}//end of main

