#include <math.h>

int Jacobi(int t_i)
{
	int i,j,k,l;		//Variables used for loops
	double diff_thread;	//Each thread's difference between the elements of after and before
	int temp=N/N_THREADS;

	//Atermwn vroxos
	for (;;)
	{
		//update the before array with the new values
		//this is not necessary for the first loop because they both have the same
		//values.
		if(t_i == 0)
		{
			temp2=before;
			before=after;
			after=temp2;
		}

		pthread_barrier_wait(&bar1);		//waiting before setting the (global) diff variable at zero
		diff=0.0;				//Setting diff and diff_thread at zero value in order to check the
							//new differences
		diff_thread=0.0;
		for(k=0;k<temp;k++)
		{
			i=t_i+k*N_THREADS;
			if( ((i!=0) && (i!=(N-1)))==1 )
			{
				//Calculate the new temperature of a specific point
				for ( j=1; j < (M-1); j++ )
				{
					*(after+i*N+j) = 0.25 * ( *(before+(i-1)*N+j) + *(before+(i+1)*N+j) + *(before+i*N+(j-1)) + *(before+i*N+(j+1)) );	
					if ( fabs(*(after+i*N+j) - *(before+i*N+j) ) > diff_thread )
					{
						diff_thread = fabs( *(after+i*N+j) - *(before+i*N+j) );	//Save the greater difference between the
													//elements of before and after array
					}
				}	
		
			}

		
		}
		pthread_barrier_wait(&bar2);
		//we make a mutex lock in order to chech the diff_threads of all processes
		//and save the biggest one to the variable with the name diff
		pthread_mutex_lock(&my_mutex);
		if(diff < diff_thread)
	       	{
			diff=diff_thread;
		}
		pthread_mutex_unlock(&my_mutex);	//unlock the thread

		//wait all the lines to be checked for their diff_thread in order that the 
		//global variable diff to have the biggest value
		pthread_barrier_wait(&bar3);
		//If we achieved the diff to be less of desired value we then exit 
		//the Jacobi Algorithm
		if ( diff <= epsilon )
			break;

	}
	//return success
	return 0;
}
