#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <pthread.h>
#include "Global.h"
#include "Functions.h"
#include <sys/time.h>
#include <time.h>


int main()
{
	int i, j, t_i = 0;	//decleration of variables used for loops
	int rc=0;
	int dim;		//dimension for the array
	char *temp;		//temporary pointer for processing the file
	FILE *file;		//pointer to FILE
	pthread_t my_threads[N_THREADS];
	struct timeval start_time, end_time;	//declaration of structs for time counting

	//initiallizing the mutexes and the barriers that we are going to use in the parallel stage of the code
	pthread_mutex_init(&my_mutex,NULL);
	pthread_barrier_init(&bar1,NULL,N_THREADS);
	pthread_barrier_init(&bar2,NULL,N_THREADS);
	pthread_barrier_init(&bar3,NULL,N_THREADS);

	temp=(char *)malloc(10*sizeof(char));  	//allocating memory for temp	

	file = fopen("input.txt", "r");		//opening the input file 
	fscanf(file,"%s",temp);			//reading from input... 
	fscanf(file,"%d",&dim);			//...array dimension...
	fscanf(file,"%s",temp);			
	fscanf(file,"%lf",&epsilon);		//...and epsilon

	N = dim;		//initializing the array lines...
	M = dim;		//...and columns

	after = (double *)malloc((N*M)*sizeof(double));		//allocating memory for after...
	before = (double *)malloc((N*M)*sizeof(double));	//...and before with the appropriate size as...
								//...it is described in the input file

	while(!feof(file))	//Reading from input file until the end of it
	{
		fscanf(file,"%d%d", &i, &j);		//...the subscripts...
		fscanf(file,"%lf", (before+i*N+j));	//...and the original values
		*(after+i*N+j)=*(before+i*N+j);		//Initializing "array" with the values of before "array"

	}
	fclose(file);		//closing the file


	gettimeofday( &start_time, NULL );	//Getting the start time

	for (t_i=0; t_i < N_THREADS; t_i++ )
	{
		//create the threads
		rc=pthread_create(&my_threads[t_i],NULL,(void*)&Jacobi,(void*)t_i);

		//if the create function send an error we print an appropriate message
		//with the number of the error
		if (rc!=0)
		{
			printf("Error...%d\n",rc);
		}
	}

	//join all the finished threads and later continue with the execution of the above code
	for (t_i=0; t_i < N_THREADS; t_i++ )
	{
		pthread_join(my_threads[t_i],NULL);
	}

	gettimeofday( &end_time, NULL );	//Getting the end time

	//Print the time (in seconds) that the Jacobi Algorithm took
	printf("seconds = %f\n", (double)((1000000 * end_time.tv_sec + end_time.tv_usec) - ( 1000000 * start_time.tv_sec + 												start_time.tv_usec))/1000000);
	file = fopen("output.txt", "w");	//create and open the output file
	for ( i=0; i < N; i++ )
	{
		for ( j=0; j < M; j++ )
		{
			fprintf(file,"%d %d %lf\n", i, j, *(before+i*N+j));	//save on the output file the results
		}
		fprintf(file,"\n");	//after every 400 lines we print a new line
					//because of the constrain that the printing script sets
	}
	fclose(file);	// close the output file

	//destroy all the mutexes and barriers that we created for the parallel stage of the code
	pthread_mutex_destroy(&my_mutex);
	pthread_barrier_destroy(&bar1);
	pthread_barrier_destroy(&bar2);
	pthread_barrier_destroy(&bar3);

}//end of main

